{    var   : }
{ F, EPS }
Unit mnb4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure mnb4e(N :Integer; M :Integer; var X :Array of Extended;
                var F :Extended; var G :Array of Extended; EST :Extended;
                var EPS :Extended; LIMIT :Integer; var IERR :Integer;
                var H :Array of Extended; var KOUNT :Integer; FUN :Proc_F1E_MN;
                GRAD :Proc_F3E_MN);

implementation

procedure mnb4e(N :Integer; M :Integer; var X :Array of Extended;
                var F :Extended; var G :Array of Extended; EST :Extended;
                var EPS :Extended; LIMIT :Integer; var IERR :Integer;
                var H :Array of Extended; var KOUNT :Integer; FUN :Proc_F1E_MN;
                GRAD :Proc_F3E_MN);
var
I,J,K,KL,L,N2,N3,N31,NJ :Integer;
ALFA,AMBDA,DALFA,DX,DY,FX,FY,GNRM,HNRM,OLDF,T,W,Z :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,_37,
_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_51,_52,_53,_54,_55,
_56;
begin

{ --------EYCOBHA MHMA---------- }
{     METO BOHA-ETEPA-AYA }

{      APAMETP: }
{      N     -PAMEPHOCT POCTPAHCTBA }
{      M     -M=N*(N+7)/2 }
{      X     -BEKTOP EPEMEHHX }
{      F     -HAEHE YHK }
{      G     -PAEHT YHK F }
{      EST   -OEHKA MHMYMA YHK F }
{      EPS   -TOHOCT BCEH MHMYMA }
{      LIMIT -MAKCMAHOE CO TEPA }
{      IERR  -PHAK OCTAHOBK POECCA: }
{            IERR=-1 - HET CXOMOCT }
{            IERR=0 - HAEH MHMYM }
{            IERR=1 - BOHEHO LIMIT TEPA }
{            IERR=2 - MIN HE CYECTBYET }
{      H     -PAO MACCB H M }
{      KOUNT -BOHEHHOE CO TEPA }
{      FUN   -OPOPAMMA BCEH YHK }
{      GRAD  -OPOPAMMA BCEH PAEHTA }

{   BCEHE YHK  PAEHTA B HAAHO TOKE. }
FUN(X,F,EPS);
GRAD(X,G,EPS,0);
{   HAAHE OPEEEH  OPMPOBAHE EHHO MATP. }
IERR := 0;
KOUNT := 0;
N2 := N+N;
N3 := N2+N;
N31 := N3+1;
_1:
K := N31;
for J:=1 to N do
 begin
  H[K-1] := 1.e0;
  NJ := N-J;
  if ( NJ ) < 0
   then goto _5
   else if ( NJ ) > 0
         then goto _2
         else goto _5;
_2:
  for L:=1 to NJ do
   begin
    KL := K+L;
_3:
    H[KL-1] := 0.e0;
   end;
_4:
  K := KL+1;
 end;
{   HAAO TEPAOHHOO KA. }
_5:
KOUNT := KOUNT+1;
{   AOMHAEM HAEHE YHK, TOKY  PAEHT. }
OLDF := F;
for J:=1 to N do
 begin
  K := N+J;
  H[K-1] := G[J-1];
  K := K+N;
  H[K-1] := X[J-1];
{   OPEEEHE BEKTOPA HAPABEH H. }
  K := J+N3;
  T := 0.e0;
  for L:=1 to N do
   begin
    T := T-G[L-1]*H[K-1];
    if ( L-J ) < 0
     then goto _6
     else if ( L-J ) > 0
           then goto _7
           else goto _7;
_6:
    K := K+N-L;
    goto _8;
_7:
    K := K+1;
_8:
   end;
_9:
  H[J-1] := T;
 end;
{   BCEM POBOHY O HAPABEH, HAEH HOPM H  G. }
DY := 0.e0;
HNRM := 0.e0;
GNRM := 0.e0;
for J:=1 to N do
 begin
  HNRM := HNRM+Abs(H[J-1]);
  GNRM := GNRM+Abs(G[J-1]);
_10:
  DY := DY+H[J-1]*G[J-1];
 end;
if ( DY ) < 0
 then goto _11
 else if ( DY ) > 0
       then goto _51
       else goto _51;
_11:
if ( HNRM/GNRM-EPS ) < 0
 then goto _51
 else if ( HNRM/GNRM-EPS ) > 0
       then goto _12
       else goto _51;
{   OPEEEHE AA  OCKA MIN BO H. }
_12:
FY := F;
ALFA := 2.e0*(EST-F)/DY;
AMBDA := 1.e0;
if ( ALFA ) < 0
 then goto _15
 else if ( ALFA ) > 0
       then goto _13
       else goto _15;
_13:
if ( ALFA-AMBDA ) < 0
 then goto _14
 else if ( ALFA-AMBDA ) > 0
       then goto _15
       else goto _15;
_14:
AMBDA := ALFA;
_15:
ALFA := 0.e0;
{   OPEEEHE OTPEKA OHOMEPHO MHMA. }
_16:
FX := FY;
DX := DY;
for I:=1 to N do
 begin
_17:
  X[I-1] := X[I-1]+AMBDA*H[I-1];
 end;
FUN(X,F,EPS);
GRAD(X,G,EPS,0);
FY := F;
DY := 0.e0;
for I:=1 to N do
 begin
_18:
  DY := DY+G[I-1]*H[I-1];
 end;
if ( DY ) < 0
 then goto _19
 else if ( DY ) > 0
       then goto _22
       else goto _36;
_19:
if ( FY-FX ) < 0
 then goto _20
 else if ( FY-FX ) > 0
       then goto _22
       else goto _22;
_20:
AMBDA := AMBDA+ALFA;
ALFA := AMBDA;
if ( HNRM*AMBDA <= 1.e10 ) 
 then goto _16;
{   HEH OCK OKABAET, TO MIN HE CYECTBYET. }
IERR := 2;
goto _56;
{   KYECKA HTEPO  BCEHE TOK OHOMEPHOO MHMYMA. }
_22:
T := 0.e0;
_23:
if ( AMBDA ) < 0
 then goto _24
 else if ( AMBDA ) > 0
       then goto _24
       else goto _36;
_24:
Z := 3.e0*(FX-FY)/AMBDA+DX+DY;
ALFA := EMax1(EMax1(Abs(Z),Abs(DX)),Abs(DY));
DALFA := Z/ALFA;
DALFA := DALFA*DALFA-DX/ALFA*DY/ALFA;
if ( DALFA ) < 0
 then goto _51
 else if ( DALFA ) > 0
       then goto _25
       else goto _25;
_25:
W := ALFA*Sqrt(DALFA);
ALFA := (DY+W-Z)*AMBDA/(DY+2.e0*W-DX);
for I:=1 to N do
 begin
_26:
  X[I-1] := X[I-1]+(T-ALFA)*H[I-1];
 end;
FUN(X,F,EPS);
GRAD(X,G,EPS,0);
if ( F-FX ) < 0
 then goto _27
 else if ( F-FX ) > 0
       then goto _28
       else goto _27;
_27:
if ( F-FY ) < 0
 then goto _36
 else if ( F-FY ) > 0
       then goto _28
       else goto _36;
_28:
DALFA := 0.e0;
for I:=1 to N do
 begin
_29:
  DALFA := DALFA+G[I-1]*H[I-1];
 end;
if ( DALFA ) < 0
 then goto _30
 else if ( DALFA ) > 0
       then goto _33
       else goto _33;
_30:
if ( F-FX ) < 0
 then goto _32
 else if ( F-FX ) > 0
       then goto _33
       else goto _31;
_31:
if ( DX-DALFA ) < 0
 then goto _32
 else if ( DX-DALFA ) > 0
       then goto _32
       else goto _36;
_32:
FX := F;
DX := DALFA;
T := ALFA;
AMBDA := ALFA;
goto _23;
_33:
if ( FY-F ) < 0
 then goto _35
 else if ( FY-F ) > 0
       then goto _35
       else goto _34;
_34:
if ( DY-DALFA ) < 0
 then goto _35
 else if ( DY-DALFA ) > 0
       then goto _35
       else goto _36;
_35:
FY := F;
DY := DALFA;
AMBDA := AMBDA-ALFA;
goto _22;
{   BCEHE PAHOCT APYMEHTOB  PAEHTOB  BYX }
{   OCEOBATEHX TEPA. }
_36:
for J:=1 to N do
 begin
  K := N+J;
  H[K-1] := G[J-1]-H[K-1];
  K := N+K;
_37:
  H[K-1] := X[J-1]-H[K-1];
 end;
{   OCTAHOB, EC YHK HE YBAA HA OCEHE TEPA. }
if ( OLDF-F+EPS ) < 0
 then goto _51
 else if ( OLDF-F+EPS ) > 0
       then goto _38
       else goto _38;
_38:
IERR := 0;
if ( KOUNT-N ) < 0
 then goto _42
 else if ( KOUNT-N ) > 0
       then goto _39
       else goto _39;
{   BCEHE PPAEH APYMEHTA  HAPABEH. }
{   OCTAHOB, EC OE H MEHE EPS. }
_39:
T := 0.e0;
Z := 0.e0;
for J:=1 to N do
 begin
  K := N+J;
  W := H[K-1];
  K := K+N;
  T := T+Abs(H[K-1]);
_40:
  Z := Z+W*H[K-1];
 end;
if ( HNRM-EPS ) < 0
 then goto _41
 else if ( HNRM-EPS ) > 0
       then goto _42
       else goto _41;
_41:
if ( T-EPS ) < 0
 then goto _56
 else if ( T-EPS ) > 0
       then goto _42
       else goto _56;
_42:
if ( KOUNT < LIMIT ) 
 then goto _43;
{   OCTAHOB, EC CO TEPA PEBOCXOT LIMIT. }
IERR := 1;
goto _56;
{   OOTOBKA K EPEOPEEEH MATP H. }
_43:
ALFA := 0.e0;
for J:=1 to N do
 begin
  K := J+N3;
  W := 0.e0;
  for L:=1 to N do
   begin
    KL := N+L;
    W := W+H[KL-1]*H[K-1];
    if ( L-J ) < 0
     then goto _44
     else if ( L-J ) > 0
           then goto _45
           else goto _45;
_44:
    K := K+N-L;
    goto _46;
_45:
    K := K+1;
_46:
   end;
  K := N+J;
  ALFA := ALFA+W*H[K-1];
_47:
  H[J-1] := W;
 end;
if ( Z*ALFA ) < 0
 then goto _48
 else if ( Z*ALFA ) > 0
       then goto _48
       else goto _1;
{   EPEOPEEEHE MATP H. }
_48:
K := N31;
for L:=1 to N do
 begin
  KL := N2+L;
  for J:=L to N do
   begin
    NJ := N2+J;
    H[K-1] := H[K-1]+H[KL-1]*H[NJ-1]/Z-H[L-1]*H[J-1]/ALFA;
_49:
    K := K+1;
   end;
 end;
{   KOHE TEPAOHHO KA. }
goto _5;
{   BOCCTAHOBEHE CTAPX HAEH YHK  APYMEHTA. }
_51:
for J:=1 to N do
 begin
  K := N2+J;
_52:
  X[J-1] := H[K-1];
 end;
FUN(X,F,EPS);
GRAD(X,G,EPS,0);
if ( GNRM-EPS ) < 0
 then goto _55
 else if ( GNRM-EPS ) > 0
       then goto _53
       else goto _55;
{   KOHTPO  OBTOPEH HEYAHO TEPA. }
_53:
if ( IERR ) < 0
 then goto _56
 else if ( IERR ) > 0
       then goto _54
       else goto _54;
_54:
IERR := -1;
goto _1;
_55:
IERR := 0;
_56:
end;

end.
